; File:     PrintIt.asm
; by:       Rui Loureiro
;------------------------------------------------------------------------------------------------------------------*****
                                include PrintIt.ini
                                
;  Data Section 
.data
_hpdc        dd 0       ; Printer Device Context handle
_hpFont      dd 0

_sPrintIt    db "Print It",0
;---------------------------------------
_FontMSSSerif   db 'MS Sans Serif',0
_FontCourierNew db "Courier New",0
_hFont0         dd 0
_oFont0         dd 0

_DocTitle    db 'Documento',0

_mColumns    dd 120             ;Number of columns  
_mLines      dd 50              ;Number of lines 
_WidthCharX  dd ?
_HeightCharY dd ?
;....................................................................................

_MenuName    db 'Menu',0        ; Definido em rsrc.rc
_hWnd        dd 0

;----------------------------------------
_ClassName   db 'WinClass',0
_WindowName  db 'Choose a Text File to Print',0
;+++++++++++++++++++++++++++++++++++++++++++++++++++
; see tute_11_3
_OurTitle       db 'Choose the file to open',0

_hFile          dd 0    ; handle
_lFile          dd 0    ; length
_BytesRead      dd 0

_FilterString   db "all Files", 0, "*.*", 0
                db "text Files", 0, "*.txt",0
                db "asm Files", 0, "*.asm",0
                db "bat Files", 0, "*.bat",0                
                db "rc Files", 0, "*.rc",0, 0
                
                ;
                dd MAXSIZE
                dd 0
_FileName       db MAXSIZE dup(0)
                db 0
                ;
                dd 5
                dd 0
_PageNum        db 5 dup (0)
                db 0

                dd 5
_MsgPage        db 'Page '

                ; 
                ; Page X string 
                ; 
                dd 18
                dd 0
_PageBuf        db 18 dup (0)
                db 0
                ;
                dd 5
                dd 0
_NumOfPages     db 5 dup (0)
                db 0
                ;
                dd 1
_SepPage        db '/'
;
                dd 16
                dd 0
_RclBuffer      db 17 dup (0)

                dd MAXCOLSIZE
                dd 0
_TestBuf        db MAXCOLSIZE dup (0)
                db 0
;  Data? Section 
.data?
;---------------------------------------
_hInstance   dd ?
_hdc         dd ?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>
;_ps          PAINTSTRUCT <>

_lf          LOGFONT <?>
_di          DOCINFO <?>
_pd          PRINTDLG <?>
_tm          TEXTMETRIC  <?>
_rc          RECT <?>
_dm          DEVMODE <>

_WidthStrPrn dd ?            ; largura dos caracteres na string
_HeigtStrPrn dd ?            ; altura

_PosPrnX     dd ?            ; posio horizontal
_PosPrnY     dd ?            ; posio vertical

_NumPixelX   dd ?
_NumPixelY   dd ?

_ScalPixelX  dd ?
_ScalPixelY  dd ?

_LastTxtBuf  dd ?
_PageNumber  dd ?
_ColPages    dd ?
;-------- For Text buffer -------------
_pTxtMem     dd ?
_pTxtBuf     dd ?
;
_pFrmMem     dd ?
_pFrmBuf     dd ?
;-------------------------------------
_hDevMem        dd ?    ; DEVMODE handle
_pDEVMODE       dd ?    ; DEVMODE pointer
_Orientation    dd ?    ; 0=vertical 1=horizontal
_PrinterLines   dd ?    ; number of lines to print
_MaxColSize     dd ?
;-------------------------------------
_ofn         OPENFILENAME <?>
;  Code Section 
.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     _hInstance, eax
    invoke  WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT
; ##############################################################################################
align 16
WinMain     proc    hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
            LOCAL   x,y:DWORD
            
            ; Window size and coordinates to center it on the screen
            ;-------------------------------------------------------
            invoke  GetSystemMetrics, SM_CXSCREEN
            shr     eax, 1
            sub     eax, $ECRAWIDTH$ / 2
            mov     x, eax
            invoke  GetSystemMetrics, SM_CXSCREEN
            shr     eax, 1
            sub     eax, $ECRAHEIGHT$ / 2
            sub     eax, 80
            mov     y, eax

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC         
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
            ;invoke  CreateSolidBrush, 0
        	mov   _wcx.hbrBackground, COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            mov    _wcx.hIcon, NULL                         ;eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   x, y, $ECRAWIDTH$, $ECRAHEIGHT$, 
                                   NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     

            ; 
            ; Allocate memory for Text buffer and Format buffer
            ; 
            mov       _hFile, 0

            call      AlugaMemo
            
            invoke    GetDC, _hWnd
            mov       _hdc, eax

            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd
            
;#############################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
AlugaMemo       proc
                ;
                mov       _pTxtMem, 0
                mov       _pTxtBuf, 0
                ;
                mov       eax, MAXCOLSIZE8        
                mov       ecx, MAXLINSIZE         ; number of lines
                mul       ecx                     ; eax = bytes needed
                
                invoke    AlocRclMem, eax
                jnc       short @F

                fn  MessageBox, _hWnd, "Sorry, unable to allocate a text buffer", " Memory Error", MB_OK
                jmp        short _next
                ;
@@:             mov       _pTxtMem, eax
                mov       _pTxtBuf, edi
;....................................................
_next:          mov     _pFrmMem, 0
                mov     _pFrmBuf, 0
                ;
                mov     eax, MAXCOLSIZE4        ; 115 columns + 1 dword
                mov     ecx, MAXLINSIZE         ; number of lines
                mul     ecx                     ; eax = bytes needed
                add     eax, 24                 ; plus 24 bytes
                invoke  AllocMemo, eax
                jnc     short @F

                fn  MessageBox, _hWnd, "Sorry, unable to allocate a format buffer", " Memory Error", MB_OK                
                ret
                ;
@@:             mov     _pFrmMem, eax            
                add     eax, 20
                mov     _pFrmBuf, eax
                ;
                mov     dword ptr [eax - MaxRegLst], MAXLINSIZE
                mov     dword ptr [eax - LenRegLst], MAXCOLSIZE4             
                call    IniBufFrm

                ret
AlugaMemo       endp
; 
; process menuitems
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu1               ; Get Printer DC 
                
                    invoke    GetPrinterDC, 50, 120

                case    IDM_Menu2               ; Choose File

                    ; 
                    ; Choose File, Open and Read
                    ; 
                    call    AbreFile

                case    IDM_Menu3               ; Print Text

                    ; 
                    ; Print Text
                    ; 
                    call    PrintText
                    
                case    IDM_Menu4               ; Close

                    invoke    SendMessage, _hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; 
DevModePtr          proc
                    ; 
                    ; Get the Memory Pointer
                    ; to DEVMODE structure
                    ; 
                    invoke      GlobalLock, _pd.hDevMode           ; memory handle
                    cmp         eax, NULL
                    jne         short @F

                    fn  MessageBox, _hWnd, "GlobalLock error","Error", MB_OK
                    stc
                    ret
                    
                    ; 
                    ; EAX = starting memory address of DEVMODE structure
                    ; 
@@:                 mov         ebx, eax
                    mov         _pDEVMODE, eax

                    ret
DevModePtr          endp
; 
GetOrientation      proc

                    mov         _Orientation, 0              ; assume 0 means vertical
                    
                    mov         _MaxColSize, MAXCOLSIZE - 31    
                    mov         _PrinterLines, PRINTERLINESV ; number of lines
                    
                    ; 
                    ; Get the Memory Pointer
                    ; to DEVMODE structure
                    ; 
                    call        DevModePtr
                    jnc         short @F
                    ret                    
                    ; 
                    ; EAX = starting memory address of DEVMODE structure
                    ; 
@@:                 mov         eax, [ebx].DEVMODE.dmFields
                    and         eax, DM_ORIENTATION
                    jnz         short @F
                    stc
                    ret

@@:                 mov         ax, [ebx].DEVMODE.dmOrientation
                    cmp         ax, DMORIENT_PORTRAIT
                    jne         short @F
                    
                    fn  MessageBox, _hWnd, "DMORIENT_PORTRAIT","Test", MB_OK
                    clc
                    ret
                    
@@:                 mov         ax, [ebx].DEVMODE.dmOrientation
                    cmp         ax, DMORIENT_LANDSCAPE
                    jne         short @F

                    fn  MessageBox, _hWnd, "DMORIENT_LANDSCAPE","Test", MB_OK

                    mov         _Orientation, 1

                    mov         _MaxColSize, MAXCOLSIZE 
                    mov         _PrinterLines, PRINTERLINESH

@@:                 clc         ; assume 0
                    ret
GetOrientation      endp
; 
; Get the number of lines per page to _PrinterLines
;
PrinterLines        proc
                    LOCAL   NumPixelY:DWORD   
                    
	              invoke  GetDeviceCaps, _hpdc, SCALINGFACTORY
                    mov     _ScalPixelY, eax
                    
                    ;invoke   ShowNumber, eax                    

	              invoke  GetDeviceCaps, _hpdc, VERTRES
                    mov     NumPixelY, eax

                    xor     edx, edx
                    mov     ecx, _ScalPixelY
                    cmp     ecx, 0
                    je      short @F
                    ;
                    div     ecx                    
                    mov     NumPixelY, eax

@@:                 invoke  GetTextMetrics, _hpdc, addr _tm
                    mov     ecx, _tm.TEXTMETRIC.tmHeight

                    mov     ebx, 3
                    cmp     _Orientation, 1
                    je      short @F
                    mov     ebx, 7

@@:                 xor     edx, edx
                    mov     eax, NumPixelY
                    div     ecx
                    ;
                    sub     eax, ebx                   
                    mov     _PrinterLines, eax
                    
                    ;invoke  ShowNumber, eax

                    ret
PrinterLines        endp
; 
; Get Printer Device Context to _hpdc
; and create a Font for _mLines=Lin and _mColumns=Col using CreateFontX
; 
GetPrinterDC        proc    Lin:DWORD, Col:DWORD
                    ;
                    mov     eax, Lin
                    add     eax, 4
                    mov     _mLines, eax
                    ;
                    mov     eax, Col
                    mov     _mColumns, eax

                    cmp     _hpdc, 0
                    je      short @F

                    invoke   DeleteObject, _hpFont
                    invoke   DeleteDC, _hpdc
                    mov     _hpdc, 0

                    ; 
                    ; Fill in _pd Structure PRINTDLG
                    ; to be used with PrintDlg
                    ; 
@@:                 mov     _pd.lStructSize, sizeof PRINTDLG
                    mov     _pd.Flags, PD_RETURNDC or PD_PRINTSETUP

                    mov     _pd.nCopies, 1
                    ; 
                    ; This values are valid only if the 
                    ; PD_PAGENUMS flag is specified
                    ; 
                    mov     _pd.nFromPage, 1
                    mov     _pd.nToPage, 1

                    mov     _pd.hDevMode, NULL
                    mov     _pd.hDevNames, NULL

                    mov     _pd.lCustData, NULL
                    mov     _pd.lpfnPrintHook, NULL         ; PD_ENABLEPRINTHOOK
                    mov     _pd.lpfnSetupHook, NULL         ; PD_ENABLESETUPHOOK
                    mov     _pd.lpPrintTemplateName, NULL
                    ;mov     _pd.lpSetupTemplateName, NULL  ; not defined in windows.inc

                    mov     _pd.hPrintTemplate, NULL
                    mov     _pd.hSetupTemplate, NULL
                    
                    ; 
                    ; PD_RETURNDEFAULT
                    ; Causes PrintDlg to return DEVMODE and DEVNAMES structures 
                    ; that are initialized for the system default printer 
                    ; ########### without displaying a dialog box ##############
                    ; 
                    ;mov     _pd.Flags, PD_RETURNDC or PD_RETURNDEFAULT
                    push     _hInstance
                    pop      _pd.hInstance  
                     
                    ;         PageSetupDlg ?
                    invoke   PrintDlg, addr _pd
                    cmp      eax, TRUE
                    je       short @F

                    mov     _hpdc, 0
                    ret

@@:                 mov     eax, _pd.hDC
                    mov     _hpdc, eax

                    ; 
                    ; Get the Memory Pointer
                    ; to DEVMODE structure
                    ; 
                    call    DevModePtr
                    jc      short @F

                    mov     ebx, _pDEVMODE
                    mov     ax, [ebx].DEVMODE.dmPaperSize
                    cmp     ax, DMPAPER_A4
                    je      short @F

                    fn      MessageBox, _hWnd, "Doesnt work properly with that paper size. Please choose A4","Warning", MB_OK

                    ; 
                    ; DMORIENT_PORTRAIT or DMORIENT_LANDSCAPE
                    ; 
@@:                 call    GetOrientation
                    ;
                    ; Pixeis na HORIZONTAL
                    ; --------------------
                    invoke  GetDeviceCaps, _hpdc, HORZRES
                    mov     _NumPixelX, eax
                    ;
                    ; Pixeis na VERICAL
                    ; -----------------
	              invoke  GetDeviceCaps, _hpdc, VERTRES
                    mov     _NumPixelY, eax                    
                    ;
                    ; para termos _mColunas ...
                    ; -------------------------
                    xor     edx, edx
                    mov     eax, _NumPixelX
                    div     _mColumns
                    mov     _WidthCharX, eax
                    ;
                    ; para termos _mLinhas ...
                    ; ------------------------
                    xor     edx, edx
                    mov     eax, _NumPixelY                                    
                    div     _mLines
        	        mov     _HeightCharY, eax

                    ; 
                    ; Font
                    ; 
                    mov       eax, _WidthCharX
        	        mov       edx, _HeightCharY
                    neg       edx
                    neg       eax
                    ;invoke    CreateFontX, addr _FontMSSSerif, edx, eax, FW_NORMAL, 0
                    ;invoke    CreateFontX, addr _FontMSSSerif, 0, eax, FW_NORMAL, 0
                    invoke    CreateFontX, addr _FontMSSSerif, 0, 0, FW_NORMAL, 0                    
                    jnc       short @F
                    ret
                    ;
@@:                 invoke    SelectObject, _hpdc, _hpFont

                    call      PrinterLines
                    ret
GetPrinterDC        endp
; ----------------------------------------------------------------------------------------------
CreateFontX     proc    pName:DWORD, Alt:DWORD, Lgr:DWORD, Typ:DWORD, ID:DWORD

                mov     eax, Typ
                mov     _lf.lfWeight, eax
                
                mov     eax, Alt
                mov     _lf.lfHeight, eax
                mov     eax, Lgr       
                mov     _lf.lfWidth, eax
                ;
                mov     _lf.lfEscapement, 0
                mov     _lf.lfOrientation, 0
                mov     _lf.lfItalic, FALSE
                mov     _lf.lfUnderline, FALSE
                mov     _lf.lfStrikeOut, FALSE
                mov     _lf.lfCharSet, ANSI_CHARSET 
                mov     _lf.lfOutPrecision, OUT_DEFAULT_PRECIS or OUT_DEVICE_PRECIS
                mov     _lf.lfClipPrecision, CLIP_DEFAULT_PRECIS
                mov     _lf.lfQuality, PROOF_QUALITY        

                mov     al, DEFAULT_PITCH or FF_MODERN
                mov     edx, ID
                cmp     edx, 0
                je      @F
                             
                mov     al, DEFAULT_PITCH or FF_ROMAN
                cmp     edx, 1
                je      @F

                mov     al, DEFAULT_PITCH or FF_SWISS
                cmp     edx, 2
                je      @F

                mov     al, DEFAULT_PITCH or FF_SCRIPT
                cmp     edx, 3
                je      @F

                mov     al, DEFAULT_PITCH or FF_DECORATIVE
                cmp     edx, 4
                je      @F
                
                mov     al, DEFAULT_PITCH or FF_DONTCARE

@@:             mov     _lf.lfPitchAndFamily, al
                ;
                mov     edx, pName
                mov     ebx, offset _lf
                ;
@@:             movzx   eax, byte ptr [edx]                
                mov     byte ptr [ebx].LOGFONT.lfFaceName, al
                ;
                inc     edx
                inc     ebx
                ;
                or      eax, eax
                jnz     short @B

                invoke  CreateFontIndirect, addr _lf
                mov     _hpFont, eax
                ;
                cmp     eax, 0
                jne     short @F

                fn  MessageBox, _hWnd, "Error while creating Font", "Font Error", MB_OK 	
                
                stc
                ret
                
@@:             clc
                ret
CreateFontX     endp
; 
; Define  _NumOfPages and _ColPages variables
;
NumOfPages      proc

                mov     ebx, _pFrmBuf
                mov     eax, dword ptr [ebx - EndRegLst]
                mov     ebx, _PrinterLines                  ;PRINTERLINES
                xor     edx, edx
                div     ebx
                or      edx, edx
                jz      short @F
                ;
                add     eax, 1
@@:             invoke  CnvToRcl, eax, addr _NumOfPages

                mov     esi, 5
                cmp     _Orientation, 0
                je      short @F
                mov     esi, 16
                ; 
                ; Column where to print Page number = _ColPages
                ; 
@@:             invoke  GetDeviceCaps, _hpdc, HORZRES
                mov     ebx, eax
                invoke  GetTextMetrics, _hpdc, addr _tm
                mov     ecx, _tm.TEXTMETRIC.tmAveCharWidth
                mov     eax, esi                              ; number of chars
                mul     ecx
                sub     ebx, eax
                ;
                xor     edx, edx
                mov     eax, ebx                
                div     ecx
                mov     _ColPages, eax

                ;invoke  ShowNumber, eax

                ret
NumOfPages      endp
; 
; Printing procedures are:
;                           PrintText that calls ...
;                           PrintPage that calls ...
;                           RclPrint  that calls TextOut
; 
; Print each line from formated buffer (Frm buffer) pointed by _pFrmBuf 
; There are [ebx - EndRegLst] strings in the buffer pointed by ebx = _pFrmBuf 
;
; 
PrintText           proc     

                    mov     ebx, _pTxtBuf
                    cmp     ebx, 0
                    je      short @F
                    ;                 
                    cmp     dword ptr [ebx - 4], 0
                    jne     short _start

@@:                 fn  MessageBox, _hWnd, "Choose a file to be printed", "Error", MB_OK 
                    ret

                    ; 
                    ; Get Printer DC 50 lines, 120 columns
                    ; 
_start:             invoke  GetPrinterDC, 50, 120

                    cmp     _hpdc, 0
                    jne     short @F
                    ret
                    
                    ; 
                    ; Format Text
                    ; 
@@:                 call      FormatTxt

                    mov     _PageNumber, 0
                    call    NumOfPages

                    mov    _di.cbSize, SIZEOF _di
                    mov    _di.lpszDocName, offset _DocTitle
                    mov    _di.lpszOutput, NULL
                    mov    _di.fwType, NULL
                    ;
                    invoke  StartDoc, _hpdc, addr _di
                    cmp     eax, 0
                    jg      short @F
                    ret
                    
@@:                 call    PrintPage
                    jnc     short @B

                    invoke  SetWindowText, _hWnd, addr _WindowName
                                     
                    invoke   DeleteObject, _hpFont
                    invoke   DeleteDC, _hpdc   
                    mov      _hpdc, 0

                    ; 
                    ; Destroy Format Buffer
                    ; 
                    call    IniBufFrm
                    mov     ebx, _pTxtBuf
                    mov     dword ptr [ebx - 4], 0

                    ret
PrintText           endp
; 
PrintPage           proc
                    LOCAL   LinCor:DWORD, MaxLin:DWORD
                    ;
                    invoke  StartPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc
                    stc
                    ret

@@:                 mov     eax, _PrinterLines
                    mov     MaxLin, eax
                    mov     LinCor, 1

                    ;...............................................                    
                    ; 
                    ; Number of the Page
                    ; 
                    inc     _PageNumber
                    invoke  CnvToRcl, _PageNumber, addr _PageNum

                    invoke  RclRclCpy, addr _MsgPage, addr _PageBuf  
                    invoke  RclRclAdd, addr _PageNum, addr _PageBuf  
                    invoke  RclRclAdd, addr _SepPage, addr _PageBuf 
                    invoke  RclRclAdd, addr _NumOfPages, addr _PageBuf  

                    invoke  RclPrint, addr _PageBuf, 1, _ColPages, $RIGHT$, 0
                    ;...............................................
                    
_start:             call    GetNxtLin
                    jnc     short @F
                    ;
                    ; Fim
                    ;
                    invoke  EndPage, _hpdc
                    invoke  EndDoc, _hpdc                    
                    stc
                    ret
                    ; 
                    ; Print at Line=LinCor, Column=4
                    ; 
@@:                 inc     LinCor
                    invoke  RclPrint, edi, LinCor, 6, $LEFT$, 0
                    ;
                    sub     MaxLin, 1
                    jnz     short _start
                    ;
@@:                 invoke  EndPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc
                    stc
                    ret
                    ;
@@:                 clc
                    ret
PrintPage           endp
; 
; Input:
;       pRcl    - points to a RCL string that has this format:
;
;                           dd ?        <- max length  at  address of _name -8
;                           dd ?        <- length      at  address of _name -4
;                   _Name   db ????????
;
RclPrint            proc    pRcl:DWORD, Lin:DWORD, Col:DWORD, Jst:DWORD, Fnt:DWORD

                    mov     ebx, pRcl
                    cmp     dword ptr [ebx - 4], 0
                    jne     short @F
                    clc
                    ret
                    
@@:                 invoke  GetPosPrn, Lin, Col

                    mov     eax, _PosPrnX
                    cmp     Jst, 0
                    je      short @F                ; Left
                    ;                 
                    invoke  GetTextExtentPoint32, _hpdc, ebx, [ebx - 4], addr _WidthStrPrn
                    mov     eax, _PosPrnX
                    sub     eax, _WidthStrPrn
                
@@:                 invoke  TextOut, _hpdc, eax, _PosPrnY, ebx, [ebx - 4]
                    clc
                    ret
RclPrint            endp
; 
;                           END of printing procedures
; 
; 
; Procedures to Get a File, Open, Read it and Close file
;
;           AbreFile: Close the previous; Get the file to open
;                     Open the file; Get its length; Read it to Text Buffer
;                     and Close it
;
;           FileRead: Read the file to Text Buffer
;
;           FileClose: Closes the file
; 
; Choose a File to open and then Open the file, get the length and  Read it to Text Buffer
;
AbreFile        proc

                ;
                ; Close the previous            
                ; 
                call      FileClose

                ; 
                ; Clean the previous
                ; 
                mov     ebx, offset _FileName

                ; 
                ; Get File Name to open OPENFILENAME
                ; 
                mov     _ofn.lStructSize, SIZEOF _ofn
                push    _hWnd
                pop     _ofn.hWndOwner

                push    _hInstance
                pop     _ofn.hInstance
                mov     _ofn.lpstrFilter, OFFSET _FilterString
                mov     _ofn.lpstrFile, OFFSET _FileName
                mov     _ofn.nMaxFile, MAXSIZE
                mov     _ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or \
                                    OFN_HIDEREADONLY
                
                mov     _ofn.lpstrTitle, OFFSET _OurTitle
                ;
                mov     _ofn.lCustData, NULL
                mov     _ofn.lpfnHook, NULL
                mov     _ofn.lpTemplateName, NULL                
                ;
                invoke  GetOpenFileName, ADDR _ofn
                cmp     eax, TRUE
                je      short @F
                
                ; 
                ; Change Window Title
                ;                 
                invoke    SetWindowText, _hWnd, addr _WindowName
                stc
                ret
                                
                ; 
                ; Open File
                ; 
@@:             invoke    CreateFile, ebx, $ModoAberRd, $ShareFic, NULL,
                                           $AbreOuErro, $ArquivoAll, NULL
                cmp       eax, INVALID_HANDLE_VALUE
                je        _erro                                       ; erro
                ;
                ; Save the handle
                ; 
                mov       _hFile, eax
                ;
                ; Get the Length
                ; 
                invoke    GetFileSize, eax, NULL
                cmp       eax, INVALIDO_SET_FILE_POINTER
                jne	  short @F
                ;
                call      SendErro
                call      FileClose                
                stc
                ret

                ; 
                ; _lFile = File Length
                ; 
@@:             mov       _lFile, eax
                cmp       eax, 0
                jne       short @F

                fn  MessageBox, _hWnd, "The File has nothing", "File Error", MB_OK
                call      FileClose
                stc
                ret
                
                ; 
                ;        Read File
                ; 
@@:             call      FileRead
                jnc       short @F
                ;
                call      FileClose
                ret

                ; 
                ;     Close File
                ; 
@@:             invoke    CloseHandle, _hFile
                mov       _hFile, 0
                ; 
                ; Change Window Title
                ; 
                invoke    SetWindowText, _hWnd, addr _FileName
                ret
                ;
_erro:          call      FileClose
                call      SendErro
                stc
                ret
AbreFile        endp 
; 
; close file
;
FileClose       proc

                cmp       _hFile, 0
                je        short @F
                
                invoke    CloseHandle, _hFile
                mov       _hFile, 0
   
@@:             invoke    SetWindowText, _hWnd, addr _WindowName
                ;
                ret
FileClose      endp
; 
; Input:
;       _hFile  - file handle
;       _lFile  - file length
;
FileRead        proc

                mov     ebx, _pTxtBuf
                cmp     ebx, 0
                jne     short @F

                fn  MessageBox, _hWnd, "Sorry, there isnt a buffer", "File Error", MB_OK
                stc
                ret
                ;             
@@:             cmp     eax, dword ptr [ebx - 8]    ; max buffer length
                jbe     short @F

                fn  MessageBox, _hWnd, "The File is too long", "File Error", MB_OK
                ;
                ; File is too long
                ; 
_erro:          mov       dword ptr [ebx - 4], 0      ; buffer length
                call      SendErro
                stc
                ret
                ;
@@:             invoke    ReadFile, _hFile, ebx, _lFile, addr _BytesRead, NULL
                cmp       eax, 0
                jne	  short @F                 ; leu
                ;
                ; Erro
                ; 
                
                jmp       _erro
;.............................................................................
@@:             mov       eax, _BytesRead
                cmp	  eax, _lFile
                je        short @F
                ;
                call      SendErro                
                stc
                ret
                ; 
                ; buffer length
                ; 
@@:             mov     dword ptr [ebx - 4], eax
                ;
                add     eax, ebx
                mov     _LastTxtBuf, eax        ; points to the end address
                                
                clc
                ret
FileRead        endp
; ##############################################################################################
IniBufFrm       proc
                mov     eax, _pFrmBuf                   
                cmp     eax, 0
                jne     short @F
                stc
                ret
                ;
@@:             mov     dword ptr [eax - EndRegLst], 0
                mov     dword ptr [eax - CorRegLst], 0
                clc
                ret
IniBufFrm       endp
; 
; Remove the line at EndRegLst if it is null or it contains spaces only
;
CleanFrm        proc

                mov     esi, _pFrmBuf
_start:         mov     eax, dword ptr [esi - EndRegLst]
                
                cmp     eax, 0
                jne     short @F
                ret
                ;
@@:             mov     ebx, esi
                sub     eax, 1
                mul     dword ptr [esi - LenRegLst]
                add     ebx, eax
                mov     ecx, dword ptr [ebx - 4]                
                cmp     ecx, 0
                je      short _next
                ;
_i:             sub     ecx, 1
                cmp     byte ptr [ebx + ecx], 20h
                je      short @F
                ret
                ;
@@:             cmp     ecx, 0
                jne     short _i
;..........................................................
_next:          mov     eax, dword ptr [esi - EndRegLst]
                sub     eax, 1
                mov     dword ptr [esi - EndRegLst], eax
                jmp     _start
CleanFrm        endp
; 
; Read Text Buffer and convert each line to Format Buffer
;
FormatTxt       proc
                ;
                call    IniBufFrm
                jnc     short @F
                ret
                ;
@@:             mov     esi, _pTxtBuf
                cmp     dword ptr [esi - 4], 0
                jne     short _start
                ret
                ;
                ;
                ;
_cnv:           call    CnvToFrm
                jnc     short _start
                
                ; 
                ; Insufficient buffer
                ; 
                ret
                ;
                ;
                ;
_start:         call    NxtLinFrm
                jnc     short @F
                
                ; 
                ; Insufficient buffer
                ;                 
                ret

@@:             call    FindCRLF
                jnc     short _next
                ;
                ; END
                ;
                cmp	ecx, _lFile
                je      short @F
                
;##########################################
                ;invoke  ShowNumber, ecx
                ;movzx   eax, byte ptr [ebx]
                ;invoke  ShowHexa, eax
;##########################################

                call    CleanFrm
                ret
                
                ; 
                ; it isnt a text file
                ; 
@@:             fn  MessageBox, _hWnd, "It isnt a text file", "Error", MB_OK
                ;
                call    IniBufFrm
                stc
                ret
                ;
_next:          cmp     ecx, 0
                je      short _start

                cmp     ecx, _MaxColSize            ;MAXCOLSIZE 
                jbe     short _cnv
                ;
                ; Line too long
                ;
                mov     eax, ecx
                sub     eax, _MaxColSize            ;MAXCOLSIZE

                push    eax
                    mov     ecx, _MaxColSize        ;MAXCOLSIZE                
                    call    CnvToFrm
                pop     ecx
                jnc     short @F

                ; 
                ; Insufficient buffer
                ;                 
                ret
                
@@:             call    NxtLinFrm
                jnc     short _next
                
                ; 
                ; Insufficient buffer
                ; 
                ret 
FormatTxt       endp
; ----------------------------------------------------------------------------------------------
; Action:
;           Convert Text Buffer string to Format Buffer string
;
; Input:
;           ECX     - line length
;           EBX     - text buffer current position
;           EDI     - frm  buffer initial line position
;
; Output:
;           clc:    OK
;
;           stc:    Insufficient buffer
;
CnvToFrm        proc

                mov     edx, edi
                ;                
_i:             movzx   eax, byte ptr [ebx]
                add     ebx, 1
                
                cmp     al, 09h
                jne     short @F
                
                ; 
                ; Convert this tab to 8 spaces
                ; 
                call    AddSpaces
                jnc     short _n
                ; 
                ; Insufficient buffer
                ; 
                ret
                ;             
@@:             push    eax
                ;
                    mov     eax, dword ptr [edi - 4]
                    inc     eax
                    cmp     eax, _MaxColSize            ;MAXCOLSIZE 
                    jbe     short @F
                    ;
                    ; Next Line
                    ;
                    call    NxtLinFrm
                    jnc     short @F

                ; 
                ; finish: Insufficient buffer
                ; 
                pop     eax
                ret


@@:             pop     eax

                inc     dword ptr [edi - 4]
                ;
                mov     byte ptr [edx], al
                add     edx, 1
                ;
_n:             sub     ecx, 1
                jnz     short _i

                ; 
                ; End
                ; 
                clc
                ret
CnvToFrm        endp
; ----------------------------------------------------------------------------------------------
AddSpaces       proc
                push    ebx
                push    ecx
                ;
                mov     ecx, dword ptr [edi - 4] 
                mov     eax, ecx
                add     eax, 8
                cmp     eax, _MaxColSize            ;MAXCOLSIZE 
                ja      short @F
                ;
                mov     dword ptr [edi - 4], eax
                
                mov     dword ptr [edx + 0], 20202020h
                mov     dword ptr [edx + 4], 20202020h                
                add     edx, 8
                clc
                pop     ecx
                pop     ebx
                ret                     
;....................................................
@@:             mov     ebx, 8                      ; each TAB = 8 spaces               
                ;
_start:         add     ecx, 1
                cmp     ecx, _MaxColSize            ;MAXCOLSIZE 
                jbe     short _next
                ;
                call    NxtLinFrm
                jc      short _exit                 ; Insufficient buffer

                mov     edx, edi
                mov     ecx, 1

_next:          mov     dword ptr [edi - 4], ecx
                mov     byte ptr [edx], 20h
                add     edx, 1
                ;
                sub     ebx, 1
                jnz     short _start
                ;
                clc
_exit:          pop     ecx
                pop     ebx
                ret
AddSpaces       endp
; ----------------------------------------------------------------------------------------------
; Input:
;           ESI     - corrente
;
; Output:
;           EBX     - inicial
;           ESI     - prximo
;
;           ECX     - comprimento
;
FindCRLF        proc

                mov     ebx, esi
                xor     ecx, ecx
                jz      short _i            ; begin
                ;
_n:             add     esi, 1
                cmp     esi, _LastTxtBuf
                jb      short _i

                ; 
                ; End_Of_File
                ; 
                mov     ecx, esi
                sub     ecx, ebx
                
                stc
                ret
                ;
_i:             movzx   eax, word ptr [esi]
                ;
                cmp     ax, 0A0Dh
                je      short _e
                
                cmp     ax, 0D0Ah
                jne     short _n
                ;
_e:             mov     ecx, esi
                sub     ecx, ebx
                
                add     esi, 2              ; next position
                clc                
                ret
FindCRLF        endp
; ----------------------------------------------------------------------------------------------
; Output:
;           clc:    EDI=EDX - points to next line buffer
;       
;
NxtLinFrm       proc

                mov     edi, _pFrmBuf                   
                mov     eax, dword ptr [edi - EndRegLst]
                add     eax, 1
                cmp     eax, dword ptr [edi - MaxRegLst]
                jbe     short @F
                ;
                ;invoke  ShowNumber, eax

                fn      MessageBox, _hWnd, "Insufficient buffer", "Warning", MB_OK
                stc
                ret
                ;
@@:             mov     dword ptr [edi - EndRegLst], eax
                ;
                sub     eax, 1
                mul     dword ptr [edi - LenRegLst]
                add     edi, eax
                mov     edx, edi
                ;
                mov     dword ptr [edi - 4], 0              ; string length  = 0
                ;                
                clc
                ret
NxtLinFrm       endp
; ----------------------------------------------------------------------------------------------
; Output:
;           clc:    EDI     - points to current frm line
;
;           stc:    END
;
GetNxtLin       proc

                mov     edi, _pFrmBuf                   
                mov     eax, dword ptr [edi - CorRegLst]
                add     eax, 1
                cmp     eax, dword ptr [edi - EndRegLst]
                jbe     short @F
                ; 
                ; END
                ; 
                stc
                ret
                ;
@@:             mov     dword ptr [edi - CorRegLst], eax
                ;
                sub     eax, 1
                mul     dword ptr [edi - LenRegLst]
                add     edi, eax
                ;                
                clc
                ret
GetNxtLin       endp
; 

                                include PrintIt.inc

; 
SendErro        proc
                pushad  
                ;
                fn  MessageBox, _hWnd, "While reading or opening the file", "File Error", MB_OK 	
                ;
                popad
                ret
SendErro        endp
; ##############################################################################################
    end     start

